\section{Link Prediction}

\begin{frame}{Link Prediction}
    \centering\input{ikg_pred.tex} 
\end{frame}

\begin{frame}{Knowledge Graph Embeddings}
    
    \textbf{Example:} ComplEx~\cite{Trouillon2016} as KGE

    \begin{align*}
        f_{\text{ComplEx}}(h, r, t) &= \realp(\embed{h}^\top
        \operatorname{diag}(\embed{r})\bar{\embed{t}})
    \end{align*}
    
    Where \(\bar{\embed{t}}\) is the complex conjugate of \(\embed{t}\) and
    \(\realp(x)\) is the real part of the complex number \(x\).
\end{frame}

\begin{frame}[allowframebreaks]{ComplEx:\ Example}
    Let \(\embed{King} = \begin{bmatrix*}0.5 + 0.25i \\ 1 + 0i\end{bmatrix*}\),
    \(\embed{It} = \begin{bmatrix*}-0.5 - 1i \\ 0.25 - 0.5i\end{bmatrix*}\) and \(\embed{wrote}
    = \begin{bmatrix*}-0.5 + 0i\\ 0.25 - 0.25i\end{bmatrix*}\) 

    Compute the score of the triple \((King, wrote, It)\) according to 
    \(f_{\text{ComplEx}}(King, wrote, It)
    = \realp(\embed{King}^\top\operatorname{diag}(\embed{wrote})\overline{\embed{It}})\)

    \begin{align*}
        &\realp(\embed{King}^\top\operatorname{diag}(\embed{wrote})\overline{\embed{It}})\\
        &\realp\left(\begin{bmatrix*} 0.5 + 0.25i & 1 + 0i\end{bmatrix*}  \begin{bmatrix*}
        -0.5 + 0i & 0\\
        0 & 0.25 - 0.25i
      \end{bmatrix*}
      \begin{bmatrix*}
          -0.5 + 1i \\ 0.25 + 0.5i
      \end{bmatrix*}\right)\\
      &\realp\left(
      \begin{bmatrix*}
          -0.25 -0.125i &  0.25 - 0.25i
            \end{bmatrix*}
            \begin{bmatrix*}
                -0.5 + 1i \\ 0.25 + 0.5i
        \end{bmatrix*}\right)\\
      &\realp(0.25 - 0.1875 i + 0.1875 + 0.0625i)\\
      &\realp(0.4375 - 0.125i) = 0.4375
    \end{align*}
\end{frame}

\begin{frame}{KGEs and Query Answering}
    How can we use KGEs (link predictors) to improve query answering?

    \centering\input{ikg_pred_cq.tex}
\end{frame}

\begin{frame}{Existing Approaches}

    \begin{columns}[t]

        \column{0.45\textwidth}
        \begin{visibleenv}<2->
            \textbf{Precompletion}

            \begin{itemize}
                \item Add all triples above a certain score 
                \item Inefficient: test up to \({|\entspace|}^2 \times |\relspace|\) triples
                \item Denser graphs harm computational performance
            \end{itemize}
        \end{visibleenv}

        \column{0.45\textwidth}
        \begin{visibleenv}<3->
        \textbf{Query Embeddings}

            \begin{itemize}
                \item Train embeddings for queries
                \item Large datasets of queries 
                \item Example: Query2Box~\cite{Ren2020} needs \(1.2 \times 10^6\) training queries for FB15k-237
            \end{itemize}
        \end{visibleenv}
    \end{columns}
    
\end{frame}

